;==========================================
; ByteToDec.asm
;==========================================
;      

ByteToDec:
		CLRF	Hundreds		; 
		CLRF	Tens			; 
		CLRF	Ones			; 
		CLRF	Tenth			;   
		CLRF	Minus			;  ""

		BTFSS	Num_DS, .0
		GOTO	Def0
		GOTO	Def1
Def0:	Definition .0
		BTFSS	FLAG_DS, .0
		RETURN
		GOTO	Def2
Def1:	Definition .1
		BTFSS	FLAG_DS, .4
		RETURN

Def2:

HundredsLoop:                   ;   
  		MOVLW  	.100
  		SUBWF  	DATA_INL, w
  		BTFSS  	STATUS, C		;   STATUS.C == 1   
   		GOTO  	TensLoop
  		MOVWF  	DATA_INL        ;    DATA_INL
  		INCF   	Hundreds, f     ;   
  		GOTO   	HundredsLoop

TensLoop:                       ;   
  		MOVLW  	.10
  		SUBWF  	DATA_INL, w
  		BTFSS  	STATUS, C       ;   STATUS.C == 1   
   		GOTO  	OnesLoop
  		MOVWF  	DATA_INL        ;    DATA_INL
  		INCF   	Tens, f         ;   
		GOTO	TensLoop

OnesLoop:                       ;   
  		MOVF	DATA_INL, w
  		ADDWF	Ones, f

;=====    ========
;=====     ============

Hundreds_switch:
		BTFSS	Hundreds, .0
		GOTO	Tens_switch		;
		GOTO	end_conv		; t=>100

Tens_switch:
		BSF		STATUS, C		;  STATUS, C  "1"
		MOVF	Tens, w
		ADDLW	-.1
		BTFSC	STATUS, C
		GOTO	Minus_Hundreds	; |10|<=t<|100|
		GOTO	Minus_Tens		;  |0|<=t<|10|
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Minus_Hundreds:
		BTFSC	Minus, .3
		GOTO	Minus_H_on		; -55<=t<=-10
		GOTO	Minus_H_off		;  10<=t<125

Minus_H_off:
		MOVLW	0x0D 			; .13
		BTFSC	Num_DS, .0
		MOVLW	0x0E 			; .14
		MOVWF	Hundreds
		GOTO	end_conv

Minus_H_on:
		MOVF	Minus, w
		MOVWF	Hundreds
		GOTO	end_conv
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Minus_Tens:
		BTFSC	Minus, .3
		GOTO	Minus_T_on		; -10<t<0
		GOTO	Minus_T_off		;  0<=t<10

Minus_T_off:
		MOVLW	0x0A
		MOVWF	Tens
		MOVLW	0x0D 			; .13
		BTFSC	Num_DS, .0
		MOVLW	0x0E 			; .14
		MOVWF	Hundreds
		GOTO	end_conv

Minus_T_on:
		MOVF	Minus, w
		MOVWF	Tens
		MOVLW	0x0D 			; .13
		BTFSC	Num_DS, .0
		MOVLW	0x0E 			; .14
		MOVWF	Hundreds
		GOTO	end_conv
;==========================================

end_conv:
		RETURN
;==========================================