;==========================================
; Indication.asm
;==========================================
;   

Indication:
		;MOVLW	0x0F
		;MOVWF	PORTA
		CLRF	PORTA

		BTFSC	step_indication, .0
		GOTO	DIGIT0
		BTFSC	step_indication, .1
		GOTO	DIGIT1
		BTFSC	step_indication, .2
		GOTO	DIGIT2
		BTFSC	step_indication, .3
		GOTO	DIGIT3
;==========================================

DIGIT0:
		MOVF	Hundreds, w
		CALL	conv_data

		;XORLW	0xFF

		MOVWF	PORTB
		;BCF		PORTA, .1
		BSF		PORTA, .1
		MOVLW	b'00000010'
		MOVWF	step_indication
		GOTO	END_Indication
;==========================================

DIGIT1:
		MOVF	Tens, w
		CALL	conv_data

		;XORLW	0xFF

		MOVWF	PORTB
		;BCF		PORTA, .2
		BSF		PORTA, .2
		MOVLW	b'00000100'
		MOVWF	step_indication
		GOTO	END_Indication
;==========================================

DIGIT2:
		MOVF	Ones, w
		CALL	conv_data

		BTFSS	Num_DS, .0
		GOTO	Z0
		GOTO	Z1
Z0:		BTFSC	Znak, .0
		ADDLW	.8
		GOTO	$+.3
Z1:		BTFSC	Znak, .1
		ADDLW	.8

		;XORLW	0xFF

		MOVWF	PORTB
		;BCF		PORTA, .0
		BSF		PORTA, .0
		MOVLW	b'00001000'
		MOVWF	step_indication
		GOTO	END_Indication
;==========================================

DIGIT3:
		MOVF	Tenth, w
		CALL	conv_data

		;XORLW	0xFF

		MOVWF	PORTB
		;BCF		PORTA, .3
		BSF		PORTA, .3
		MOVLW	b'00000001'
		MOVWF	step_indication
		GOTO	END_Indication
;==========================================

END_Indication:

		RETURN
;==========================================