;==========================================
;     .
;==========================================
Setflag MACRO	K

		LOCAL	INTERR1
		LOCAL	INTERR2
		LOCAL	FLAG1
		LOCAL	FLAG2
		LOCAL	ENDSET

		;   
		BSF		INT_ON_1msec, .0	;  

INTERR1:
		BCF		STATUS, Z
		DECF	COUNT0, f
		BTFSS	STATUS, Z
		GOTO	INTERR2
		MOVLW	.250
		MOVWF	COUNT0

		BCF		STATUS, Z
		DECF	COUNT1, f
		BTFSS	STATUS, Z
		GOTO	INTERR2

		;     5 
		MOVLW	.2	;.20
		BTFSS	FLAG_DS, .3		;   0-    1 
		BTFSC	FLAG_DS, .7		;   1-    1 
		MOVLW	.20
		MOVWF	COUNT1
		BSF		INT_ON_5sec, .0		;    

		MOVLW	0x01
		XORWF	Num_DS, f

		BTFSS	FLAG_DS, (.0+K*.4)
		GOTO	INTERR2
		BTFSC	FLAG_DS, (.3+K*.4)
		GOTO	INTERR2
		BTFSS	FLAG_DS, (.2+K*.4)
		GOTO	FLAG1
		GOTO	FLAG2

FLAG1:	BSF		FLAG_DS, (.2+K*.4)
		GOTO	INTERR2

FLAG2:	BSF		FLAG_DS, (.3+K*.4)
		BSF		Znak, (.0+K)

INTERR2:
		BTFSC	FLAG_DS, (.2+K*.4)	;      
		BTFSC	FLAG_DS, (.3+K*.4)	;      1 
		GOTO	ENDSET
		;   ,   "----"
		MOVLW	0x0B
		MOVWF	Hundreds			; 
		MOVWF	Tens				; 
		MOVWF	Ones				; 
		MOVWF	Tenth				;   
		BCF		Znak, (.0+K)		;      Indication.asm

ENDSET:
		ENDM
;==========================================

;==========================================
;        DS18B20  DS18S20.
;     ByteToDec.asm
;==========================================
Definition MACRO K
; K = 0||1 0- , 1- 
;==========================================

		LOCAL	Def_DS18S20
		LOCAL	Def_DS18B20
		LOCAL	DS18S20
		LOCAL	sign_temp_DS18S20
		LOCAL	positive_temp_DS18S20
		LOCAL	negative_temp_DS18S20
		LOCAL	format_data_DS18S20
		LOCAL	Tenth_00
		LOCAL	Tenth_05
		LOCAL	DS18B20
		LOCAL	sign_temp_DS18B20
		LOCAL	positive_temp_DS18B20
		LOCAL	negative_temp_DS18B20
		LOCAL	format_data_DS18B20
		LOCAL	ERR_DS
		LOCAL	END_Def

;==========================================
		BTFSS	FLAG_DS, (.0+K*.4)
		GOTO	Def_DS18S20
		BTFSS	FLAG_DS, (.1+K*.4)
		GOTO	DS18S20
		GOTO	DS18B20
;==========================================

;    (DS18S20  DS18B20)
Def_DS18S20:
		BSF		STATUS, C		;  STATUS, C  "1"
		MOVF	DATA_INH, w
		ADDLW	-.1
		BTFSC	STATUS, C
		GOTO	Def_DS18B20
		BCF		STATUS, Z		;  STATUS, Z  "0"
		MOVF	DATA_INL, w
		ADDLW	-.170
		BTFSS	STATUS, Z
		GOTO	ERR_DS
		GOTO	DS18S20

Def_DS18B20:
		BCF		STATUS, Z		;  STATUS, Z  "0"
		MOVF	DATA_INH, w
		ADDLW	-.5
		BTFSS	STATUS, Z
		GOTO	ERR_DS
		BCF		STATUS, Z		;  STATUS, Z  "0"
		MOVF	DATA_INL, w
		ADDLW	-.80
		BTFSS	STATUS, Z
		GOTO	ERR_DS
		GOTO	DS18B20
;==========================================

DS18S20:
		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		;   
sign_temp_DS18S20:
		BTFSS	DATA_INH, .7
		GOTO	positive_temp_DS18S20
		GOTO	negative_temp_DS18S20

positive_temp_DS18S20:
		MOVLW	0x00
		MOVWF	Minus
		GOTO	format_data_DS18S20

negative_temp_DS18S20:
		MOVLW	0x0B			;   ""
		MOVWF	Minus
		;MOVLW	0xFE
		;XORWF	DATA_INL, w
		COMF	DATA_INL, w		;  DATA_INL
		ADDLW	.1				;  2???
		MOVWF	DATA_INL
		GOTO	format_data_DS18S20
		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		;     
		;    
format_data_DS18S20:
		CLRF	Tenth
		RRF		DATA_INL, f		;  - w
		;     
		BCF		DATA_INL, .7
		;ANDLW	0x7F			; 
		;MOVWF	DATA_INL		; 
		;    (0,0  0,5 )
		BTFSS	STATUS, C
		GOTO	Tenth_00
		GOTO	Tenth_05

Tenth_00:
		MOVLW	.0				; +0,0 
		GOTO	$+.2
Tenth_05:
		MOVLW	.8				; +0,5 
		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		;BSF		PCLATH, .3	;  1  
		CALL	conv_tenth		;    
		;BCF		PCLATH, .3	;  0  

		MOVWF	Tenth
		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		;     
		;    
		BSF		FLAG_DS, (.0+K*.4)
		BCF		FLAG_DS, (.1+K*.4)
		BSF		FLAG_DS, (.2+K*.4)
		GOTO	END_Def

;==========================================
DS18B20:
		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		;   
sign_temp_DS18B20:
		BTFSS	DATA_INH, .7
		GOTO	positive_temp_DS18B20
		GOTO	negative_temp_DS18B20

positive_temp_DS18B20:
		MOVLW	0x00
		MOVWF	Minus
		GOTO	format_data_DS18B20

negative_temp_DS18B20:
		MOVLW	0x0B			;   ""
		MOVWF	Minus
		COMF	DATA_INH, f		;  DATA_INH
		COMF	DATA_INL, w		;  DATA_INL

		BCF		STATUS, Z		;  STATUS, Z  "0"
		ADDLW	.1
		MOVWF	DATA_INL
		BTFSC	STATUS, Z		;  DATA_INL==0, 
		INCF	DATA_INH, f		; DATA_INH++

		GOTO	format_data_DS18B20
		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		;   
		;      
format_data_DS18B20:
		;    DS18B20
		;BSF		STATUS, C		;  STATUS, C  "1"
		;MOVF	DATA_INL, w
		;ADDLW	-.4
		;MOVWF	DATA_INL
		;BTFSS	STATUS, C
		;DECF	DATA_INH, f
		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		;   
		MOVF	DATA_INL, w
		ANDLW	0x0F

		;BSF		PCLATH, .3	;  1  
		CALL	conv_tenth		;    
		;BCF		PCLATH, .3	;  0  

		MOVWF	Tenth
		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		;     
		MOVLW	0xF0
		ANDWF	DATA_INL
		MOVLW	0x0F
		ANDWF	DATA_INH, w
		ADDWF	DATA_INL, f
		SWAPF	DATA_INL, f
		;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

		;     
		;    
		BSF		FLAG_DS, (.0+K*.4)
		BSF		FLAG_DS, (.1+K*.4)
		BSF		FLAG_DS, (.2+K*.4)	;  

		GOTO	END_Def
;==========================================

;    DS (  MAIN.asm) -
;      .
ERR_DS:
		BCF		INT_ON_5sec, .0

		MOVLW	(0x0D+K)
		MOVWF	Hundreds
		MOVLW	0x00 ; .0
		MOVWF	Tens
		MOVLW	0x0C ; .12
		MOVWF	Ones
		MOVLW	0x0C ; .12
		MOVWF	Tenth
		BCF		FLAG_DS, (.0+K*.4)
		BCF		FLAG_DS, (.1+K*.4)
		BCF		FLAG_DS, (.2+K*.4)
		BCF		FLAG_DS, (.3+K*.4)
		BCF		Znak, (.0+K)
;==========================================

END_Def:
		ENDM
;==========================================

